'Yashnov Dmitry N.Novgorod
'*********************************
'*   Boat Comp V.1  Y.D.E. 2013  *
'*********************************

'    
'GPS ,,   ,  , ,  ,, GPS ,  ,
', 

'***FUSES***
'Boden level - 1
'Boden - 0
'Ext Crystal 101111
'OCD - 1
'JTAG - 1
'SPI - 0
'CKOPT - 1
'Erase EEPROM - 0
'Boot size - 00
'Reset vector -1
'******
'1wire  - PORTA.1
'Umeter - PORTA.4 (ADC4)
'Taho   - PORTB.1 (T1)
'Kn1    - PORTA.3
'Kn2    - PORTA.2
'

$regfile = "m16def.dat"
$crystal = 11059000
$baud = 9600

$hwstack = 40
$swstack = 20
$framesize = 40

Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0
Config Lcd = 20 * 4
Config Serialin = Buffered , Size = 100
Config Adc = Single , Prescaler = Auto , Reference = Internal_2.56
Start Adc
Config 1wire = Porta.1
Config Watchdog = 2048

Const Delitel = 1                                           '      
Const T_control = 95                                        '    

Dim Flag As Bit
Dim Data_izm As Bit
Dim Tputi_h As Byte
Dim Tputi_m As Byte
Dim Tputi_s As Byte

Dim Tputi_h_last As Byte
Dim Tputi_m_last As Byte

Dim Kn_on As Bit

Dim Um As Byte
Dim Uh As Byte
Dim C As Byte , A As Byte
Dim Dsp As Byte
Dim Dsp1 As Byte
Dim Spd0 As Byte
Dim Ar(8) As Byte
Dim Leng As Byte
Dim Hh As Byte
Dim Max_speed As Byte

Dim U As Word


Dim T As Integer , I As Integer
Dim Speed As Integer
 Dim Road_last As Single
 Dim Spd2 As Single
 Dim Spd3 As Single
 Dim Road As Single

 Dim Road_all As Single
 Dim Road_day As Single
 Dim Tah As Single
Dim Moto_h As Integer
Dim Moto_m As Byte
Dim Moto_s As Byte

Dim Day As String * 2
Dim T_day As String * 2

Dim Temp As String * 6
Dim Uts As String * 10
Dim Hhs As String * 2
Dim Mm As String * 2
Dim Dot As String * 1
Dim Av As String * 2
Dim Lat As String * 12
Dim Ns As String * 2
Dim Lon As String * 13
Dim Ew As String * 2
Dim Spd As String * 6
Dim Crs As String * 6
Dim Da4 As String * 8
Dim Sat As String * 2
Dim Gpsfix As String * 1
Dim Ee_road_last As Eram Single
Dim Ee_road_all As Eram Single
Dim Ee_road_day As Eram Single
Dim Ee_tputi_h As Eram Byte
Dim Ee_tputi_m As Eram Byte
Dim Ee_max_speed As Eram Byte
Dim Ee_day As Eram String * 2
Dim Ee_moto_h As Eram Integer
Dim Ee_moto_m As Eram Byte
Dim Ee_moto_s As Eram Byte

Deflcdchar 0 , 19 , 9 , 5 , 18 , 29 , 1 , 1 , 32            '   
Deflcdchar 1 , 32 , 32 , 10 , 31 , 17 , 31 , 31 , 32        '
Deflcdchar 5 , 24 , 26 , 2 , 7 , 2 , 2 , 3 , 32             '

Declare Sub Getline
Declare Sub Wait_for_string(byval S As String)
Declare Function Read_string() As String

Config Timer0 = Timer , Prescale = 256
Config Timer1 = Counter , Edge = Falling                    '  
On Timer0 Pulse:                                            '   


Config Pinb.1 = Input                                       '
Config Pinb.3 = Input                                       '  AIN1  
Config Aci = On , Compare = Off , Trigger = Rising          '      

On Aci Save_eeprom                                          '        EEPROM


Config Porta = Input
Kn1 Alias Pina.3
Kn2 Alias Pina.2

Cls
Cursor Off Noblink

Data_izm = 0
Dsp = 1
Uts = "0"
Road = 0
Flag = 0
Tputi_h = 0
Tputi_m = 0
Tputi_s = 0


If Kn2 = 0 Then                                             '       2      
  Cls
  Locate 2 , 1 : Lcd "     Erase ODO"
  Ee_road_all = 0
  Ee_road_day = 0
  Day = "01"
  Ee_road_last = 0
  Ee_tputi_h = 0
  Ee_tputi_m = 0
  Ee_max_speed = 0
  Ee_moto_m = 0
  Ee_moto_h = 0
  Ee_moto_s = 0
  Wait 1
End If
'    EEPROM
Road_last = Ee_road_last
Road_all = Ee_road_all
Road_day = Ee_road_day
Max_speed = Ee_max_speed
Tputi_h_last = Ee_tputi_h
Tputi_m_last = Ee_tputi_m
Day = Ee_day
Moto_m = Ee_moto_m
Moto_h = Ee_moto_h
Moto_s = Ee_moto_s

'
Cls
Locate 1 , 1 : Lcd "                    "
Locate 2 , 1 : Lcd "   Boat Comp V1.0   "
Locate 3 , 1 : Lcd "    Y.D.E. 2013     "
Locate 4 , 1 : Lcd "                    "
Wait 1

'
Enable Interrupts
Enable Timer0
Enable Aci
Start Ac
Start Watchdog                                              'start the watchdog timer

' 
Loop:
' DS18b20
1wreset                                                     ' reset the bus
1wwrite &HCC                                                ' skip rom
1wwrite &H44                                                ' Convert T

Call Wait_for_string( "$GPGGA,")                            '    ,   $GPGGA,
   Sat = Read_string()                                      '   $GPGGA  
   Sat = Read_string()                                      '    
   Sat = Read_string()                                      '
   Sat = Read_string()                                      '
   Sat = Read_string()                                      '
   Gpsfix = Read_string()                                   ' 0    
   Sat = Read_string()                                      '   

 Call Wait_for_string( "$GPRMC,")                           '    ,   $GPRMC,
                                                            '   $GPRMC  
   Uts = Read_string()                                      '  
   Av = Read_string()

   Lat = Read_string()                                      '
   Leng = Len(lat) - 1                                      '
   Lat = Left(lat , Leng)                                   '

   Ns = Read_string()                                       ' 
   Leng = Len(ns) - 1                                       '
   Ns = Left(ns , Leng)                                     '

   Lon = Read_string()                                      '
   Leng = Len(lon) - 1                                      '
   Lon = Left(lon , Leng)                                   '

   Ew = Read_string()                                       ' 
   Leng = Len(ew) - 1                                       '
   Ew = Left(ew , Leng)                                     '

   Spd = Read_string()                                      '    
   Leng = Len(spd) - 1                                      '
   Spd = Left(spd , Leng)                                   '

   Crs = Read_string()                                      ' 
   Leng = Len(crs) - 1                                      '
   Crs = Left(crs , Leng)                                   '

   Da4 = Read_string()                                      '
   Da4 = Left(da4 , 6)                                      '



    Spd2 = Val(spd)
    Spd2 = Spd2 * 1.852                                     '     /
   If Gpsfix = "0" Then Spd2 = 0                            '   GPS        
    Speed = Int(spd2)                                       '     

   If Speed > Max_speed Then Max_speed = Speed              '  
   Spd3 = Spd2 / 3600                                       '    1 

   If Spd2 > 2 Then                                         '   2 /   
      Road = Road + Spd3
      Road_day = Road_day + Spd3                            ' 
      Road_all = Road_all + Spd3                            '  

   End If

   Hhs = Left(uts , 2)                                      '  
   Hh = Val(hhs)
   Mm = Mid(uts , 3 , 2)

   Hh = Hh + 4                                              '     (  +4    )
   If Hh > 23 Then Hh = Hh - 24

    T_day = Left(da4 , 2)                                   '   
   If Gpsfix <> "0" Then
    If Day <> T_day Then                                    '      
    Day = T_day
    Ee_day = Day
    Ee_road_day = 0
    Road_day = 0
    End If
   End If
   If Gpsfix <> "0" And Speed > 3 Then Data_izm = 1         '      3 /       eeprom
   Flag = Not Flag                                          '  
If Flag = 1 Then                                            '   
 Dot = ":"
Else
 Dot = " "
End If
'********     *********
If Spd2 > 2 Then Incr Tputi_s
'Incr Tputi_s
If Tputi_s > 59 Then
 Incr Tputi_m
 Tputi_s = 0
End If
If Tputi_m > 59 Then
 Incr Tputi_h
 Tputi_m = 0
End If


'**************  ***************
  U = Getadc(4)                                             ' 
  Shift U , Right , 2                                       ' 12   8
  'U = U / 2
  Um = U Mod 10 : Uh = U - Um : Uh = Uh / 10                '    
'**************************************'
' DS18b20
1wreset                                                     'reset
1wwrite &HCC                                                ' 
1wwrite &HBE                                                ' 

For I = 1 To 9
  Ar(i) = 1wread()                                          'place into array
Next
 T = 0                                                      ' 
 T = Makeint(ar(1) , Ar(2))
 T = T * 10
 T = T / 16
I = T Mod 10 : T = T - I : T = T / 10
If I < 0 Then I = I * -1

If T > T_control Then Dsp = 5                               '  

Reset Watchdog

If Dsp1 <> Dsp Then                                         ' 
 Dsp1 = Dsp
 Cls
 Kn_on = 1
End If

' 
Tah = Timer1
Tah = Tah / 16.6                                            '     
Tah = Tah / Delitel                                         '      
'******   ********
If Tah > 0.2 Then                                           '   200   
 Incr Moto_s
 If Moto_s > 59 Then
  Incr Moto_m
  Moto_s = 0
 End If
 If Moto_m > 59 Then
  Incr Moto_h
  Moto_m = 0
 End If
End If

'*******   ****************
If Dsp = 5 Then
 If Flag = 1 Then                                           '  
  Locate 1 , 1 : Lcd "####################"
  Locate 2 , 1 : Lcd "#### WARNING!!! ####"
  Locate 3 , 1 : Lcd "#### t " ; T ; "." ; I ; " C "
  Locate 3 , 16 : Lcd " ####"
  Locate 4 , 1 : Lcd "####################"
 Else
  Locate 1 , 1 : Lcd "                    "
  Locate 2 , 1 : Lcd "     WARNING!!!     "
  Locate 3 , 1 : Lcd "     t " ; T ; "." ; I ; " C "
  Locate 3 , 16 : Lcd "     "
  Locate 4 , 1 : Lcd "                    "
 End If
End If

'********   *************************
If Dsp = 1 Then
' 

If Tah > 0.1 Then
Locate 2 , 1 : Lcd "Tah " ; Fusing(tah , "#.#") ; " Rpm "
Else
Locate 2 , 1 : Lcd "               "
End If

Timer1 = 0

'  - 
 If Gpsfix <> "0" Then
  Locate 1 , 1 : Lcd Chr(0) ; Sat ; "   " ; Left(da4 , 2) ; "/" ; Mid(da4 , 3 , 2) ; "/" ; Right(da4 , 2) ; "  "
 Else
  Locate 1 , 1 : Lcd "Connecting...  "
 End If
 '
 If Hh < 10 Then
   Locate 1 , 16 : Lcd "0" ; Hh ; Dot ; Mm
 Else
   Locate 1 , 16 : Lcd Hh ; Dot ; Mm
 End If
 '
 Locate 2 , 16
 If T = 0 Then Lcd "     "
 If T < 0 Then Lcd Chr(5) ; T ; " "
 If T > 0 And T < 10 Then Lcd Chr(5) ; T ; "." ; I ; "C"    '
 If T >= 10 And T < 100 Then Lcd Chr(5) ; T ; "." ; I       '
 If T >= 100 Then Lcd Chr(5) ; T ; "C"
 '
 If Uh < 11 Then
  If Flag = 0 Then
   If Uh >= 10 Then
    Locate 3 , 16 : Lcd Chr(1) ; Uh ; "." ; Um              '; "v"
   Else
    Locate 3 , 16 : Lcd Chr(1) ; " " ; Uh ; "." ; Um
   End If
  Else
   Locate 3 , 16 : Lcd "     "
  End If
 Else
  If Uh >= 10 Then
   Locate 3 , 16 : Lcd Chr(1) ; Uh ; "." ; Um               '; "v"
  Else
   Locate 3 , 16 : Lcd Chr(1) ; " " ; Uh ; "." ; Um
  End If
 End If
 '
 Locate 3 , 1 : Lcd "Spd< " ; Speed ; " >km/h "

 '
 Locate 4 , 1
 If Road >= 100 Then Lcd "Odo " ; Fusing(road , "####.#") ; "km "
 If Road >= 10 And Road < 100 Then Lcd "Odo 0" ; Fusing(road , "####.#") ; "km "
 If Road < 10 Then Lcd "Odo 00" ; Fusing(road , "####.#") ; "km "


 '  
 If Tputi_h < 10 Then
  Locate 4 , 13 : Lcd "0" ; Tputi_h ; ":"
 Else
  Locate 4 , 13 : Lcd Tputi_h ; ":"
 End If
 If Tputi_m < 10 Then
  Locate 4 , 16 : Lcd "0" ; Tputi_m ; ":"
 Else
  Locate 4 , 16 : Lcd Tputi_m ; ":"
 End If
 If Tputi_s < 10 Then
  Locate 4 , 19 : Lcd "0" ; Tputi_s
 Else
  Locate 4 , 19 : Lcd Tputi_s
 End If


End If


'********   *************************
If Dsp = 2 Then
 Locate 1 , 1 : Lcd "Cy " ; Sat ; " c " ; Gpsfix ; " "
 Locate 2 , 1 : Lcd "p " ; Lat ; " " ; Ns
 Locate 3 , 1 : Lcd "o " ; Lon ; " " ; Ew
 Locate 4 , 1 : Lcd "Copoc " ; Fusing(spd2 , "###.#") ; " K/ "
End If
'********   *************************
If Dsp = 3 Then
 Locate 1 , 1 : Lcd "Max Speed " ; Max_speed ; " km/h "
 Locate 2 , 1 : Lcd "Last " ; Fusing(road_last , "####.#") ; "km "
 Locate 3 , 1 : Lcd "Day  " ; Fusing(road_day , "####.#") ; "km "
 Locate 4 , 1 : Lcd "All  " ; Fusing(road_all , "####.#") ; "km "

 If Tputi_h_last < 10 Then
  Locate 2 , 14 : Lcd "<0" ; Tputi_h_last ; ":"
 Else
  Locate 2 , 14 : Lcd "<" ; Tputi_h_last ; ":"
 End If
 If Tputi_m_last < 10 Then
  Locate 2 , 18 : Lcd "0" ; Tputi_m_last ; ">"
 Else
  Locate 2 , 18 : Lcd Tputi_m_last ; ">"
 End If
End If
'********   *************************
If Dsp = 4 Then
 Locate 1 , 5 : Lcd "Moto hours "
 Locate 3 , 1 : Lcd "   << " ; Moto_h ; "h " ; Moto_m ; "m " ; Moto_s ; "s >> "
End If

Goto Loop




'------------------------------------------------------
Sub Wait_for_string(byval S As String) As String            '    $GPRMC   GPS 
Local Ii As Byte
Local Cc As Byte
Ii = 1
M1:
   Cc = Waitkey()
   If Cc <> Mid(s , Ii , 1) Then
      Goto M1
   Else
      Incr Ii
      If Ii > Len(s) Then Goto M2
      Goto M1
   End If
M2:
End Sub

'------------------------------------------------------         ' " "  $GPRMC  
Function Read_string() As String
Local Cc As Byte
Local Ss As String * 14

Ss = ""
Do
   Cc = Waitkey()                                           ' 
      If Cc <> "," Then Ss = Ss + Chr(cc)

Loop Until Cc = ","
Cc = ""
Read_string = Left(ss , 12)
End Function
End



Save_eeprom:
Reset Watchdog                                              '      EEPROM   .   0.1   
If Data_izm = 1 Then                                        '    (gpsfix=0  <3)   
Ee_road_last = Road
Ee_road_all = Road_all
Ee_road_day = Road_day
Ee_tputi_h = Tputi_h
Ee_tputi_m = Tputi_m
Ee_max_speed = Max_speed
Data_izm = 0
End If
Ee_moto_m = Moto_m
Ee_moto_h = Moto_h
Ee_moto_s = Moto_s

Return

Pulse:                                                      '


 If Kn1 = 0 And Kn_on = 1 Then
  Incr Dsp
  Kn_on = 0
  If Dsp > 4 Then Dsp = 1
 End If

Return


End